<?php
function tinyturing_hidden_field($args, &$ctx) {
	$tt = $ctx->stash('TinyTuring');
	$crypted = substr($tt['hidden'], 2);
	return <<<HTML
<input type="hidden" name="$crypted" value="1" />
HTML;
}
function tinyturing_field($args, &$ctx) {
	return <<<HTML
<input type="text" name="tinyturing" style="width:30px;" />
HTML;
}
function tinyturing_letter($args, &$ctx) {
	$tt = $ctx->stash('TinyTuring');
	return $tt['letter'];
}
function tinyturing_start($args, &$ctx) {
	$words = array('annihilate', 'beat', 'cancel', 'defeat', 'eliminate', 'forbid', 'gun down', 'hinder', 'inhibit', 'jettison', 'kill', 'liquidate', 'mitigate', 'negate', 'obliterate', 'prevent', 'quash', 'reduce', 'smash', 'terminate', 'unload', 'veto', 'wipe out', 'x out', 'you can help stop', 'zap');
	$cfg = tinyturing_config($ctx);
	$tt = array();
	$let = rand(0, 25);
	$alph = array();
 	for ($a = 97; $a < (97 + 26); $a++) {
 		$alph[] = chr($a);
 	}
 	$tt['letter'] = $alph[$let];
	$tt['word'] = ucfirst($words[$let]);
	$tt['hidden'] = crypt($tt['letter'], $cfg['salt']);
	$ctx->stash('TinyTuring', $tt);
	return '';
}
function tinyturing_word($args, &$ctx) {
	$tt = $ctx->stash('TinyTuring');
	return $tt['word'];
}

function tinyturing_config($ctx) {
    $config = $ctx->stash('tinyturing_config');
    if ($config)
        return $config;
    $blog_id = $ctx->stash('blog_id');
    $config = $ctx->mt->db->fetch_plugin_config('TinyTuring', 'blog:' . $blog_id);
    if (!$config)
        $config = $ctx->mt->db->fetch_plugin_config('TinyTuring');
    if (!$config)
        $config = array('enabled' => 1, 'rejected' => 'junk');
    $ctx->stash('tinyturing_config', $config);
    return $config;
}

?>